#ifndef _MANDELBARMENGE_HPP_
#define _MANDELBARMENGE_HPP_

#include "complexfractal.hpp"

/**
  * Mandelbar-Menge.
  *
  * @author Marcell Dietl
  */
class Mandelbarmenge : public ComplexFractal
{
public:
    /**
      * Berechnet den Wert f&uuml;r einen bestimmten Punkt.
      *
      * @param s Punkt in der komplexen Zahlenebene, f&uuml;r den die Berechnung durchgef&uuml;hrt werden soll.
      * @param precision Genauigkeit mit der die einzelnen Pixel gerendert werden soll.
      * @param optimized Aktivieren des optimierten Escape-Time-Algorithmus.
      * @return Ergebnis der Berechnung, liegt im Intervall [0; 1].
      */
    virtual double calculate(const std::complex<double>& s, int precision, bool optimized) const;
};

#endif // _MANDELBARMENGE_HPP_
