#ifndef _PARAMETRIZEDCOMPLEXFRACTAL_HPP_
#define _PARAMETRIZEDCOMPLEXFRACTAL_HPP_

#include "complexfractal.hpp"

/**
  * Interface f&uuml;r Fraktale in der komplexen Zahlenebene mit zus&auml;tzlichem Parameter.
  *
  * @author Sebastian Flothow, Marcell Dietl
  */
class ParametrizedComplexFractal : public ComplexFractal
{
public:
    /**
      * Gibt den aktuellen Wert des Parameters zur&uuml;ck.
      *
      * @return Aktueller Wert des Parameters.
      */
    virtual std::complex<double> getParam() const = 0;
    /**
      * Setzt den Parameter auf einen neuen Wert.
      *
      * @param p Wert, auf den der Parameter gesetzt werden soll.
      */
    virtual void setParam(const std::complex<double>& p) = 0;

    /**
      * Virtueller Destruktor, damit delete f&uuml;r einen ParametrizedComplexFractal-Pointer korrekt funktioniert.
      */
    virtual ~ParametrizedComplexFractal() {}
};

#endif // _PARAMETRIZEDCOMPLEXFRACTAL_HPP_
